package io.github.iainvm.go.players.ai;

import io.github.iainvm.go.game.GameLogic;

import java.util.ArrayList;

public class MCT extends AI {

    //Constructor
    public MCT(int pID){
        super(pID);
    }


    //Create many children of current node to simulate
    @Override
    public void expandChildren(TreeNode tn){
        //Get legal moves
        ArrayList<Integer> legalMoves = GameLogic.getLegalMoves(tn.gs);

        int move, amount;

        amount = legalMoves.size();

        for(int i = 0; i < amount; i++){
            move = legalMoves.get(i);

            if(!tn.children.containsKey(move)){
                tn.children.put(move, new TreeNode(tn, GameLogic.makeMove(tn.gs, move)));
            }
        }
    }

}