package io.github.iainvm.go.players.ai;

import matlabcontrol.*;
import matlabcontrol.extensions.MatlabNumericArray;
import matlabcontrol.extensions.MatlabTypeConverter;

import java.util.ArrayList;
import java.util.Random;

public class MatLabContainer {

    // create proxy
    MatlabProxyFactoryOptions options;
    MatlabProxyFactory factory;
    MatlabProxy proxy;


    //Used to convert datatypes
    MatlabTypeConverter processor = new MatlabTypeConverter(proxy);


    public  MatLabContainer() throws MatlabConnectionException {
        System.out.println("Making MatLab connection");
        // create proxy
        options = new MatlabProxyFactoryOptions.Builder()
                .setUsePreviouslyControlledSession(true)
                .build();
        factory = new MatlabProxyFactory(options);
        proxy = factory.getProxy();


        //Used to convert datatypes
        processor = new MatlabTypeConverter(proxy);
        System.out.println("Matlab connection made");
    }

    public void setupVariable(double[][] array){

        //Create variables in Matlab environment
        try {
            processor.setNumericArray("array", new MatlabNumericArray(array, null));

            proxy.setVariable("move", -2);

        } catch (MatlabInvocationException e) {
            e.printStackTrace();
            System.out.println("An issue has occured while setting up variables this could be your connection to matlab, please check");
        }
    }

    public double[] runNN(int pID){
        try {
            proxy.eval("addpath('C:\\Users\\IainV\\IdeaProjects\\GoGame\\out\\production\\GoGame')");
            proxy.eval("move = NN" + pID + "(array)");

            double[] board = (double[]) proxy.getVariable("move");

            return board;

        } catch (MatlabInvocationException e) {
            e.printStackTrace();
        }
        return null;
    }

    public void disconMatLab(){
        try {
            proxy.eval("rmpath('C:\\Users\\IainV\\IdeaProjects\\GoGame\\out\\production\\GoGame')");
        } catch (MatlabInvocationException e) {
            e.printStackTrace();
        }
        proxy.disconnect();
    }
}
